# 農薬検査所DB用携帯農薬検索システム(サブ CGI)
# 使用目的かな->漢字変換
# Version 2.5.0 Copyright(C) 2006 Hidemi Oya

package dic;

# 使用目的
sub purpose {
  $_ = $_[0];
  s/テキカ/摘果/;
  s/テキ(ハ|バ)ナ/摘花/;
  s/テキボク/摘木/;
  s/マビギ/間引/;
  s/セイシ/整枝/;
  s/センテイ/剪定/;
  s/カリコミ/刈込/;
  s/ハンモ/繁茂/;
  s/ザ(ッ|ツ)ソウ/雑草/;
  s/シンショウ/新梢/;
  s/セ(ツ|ッ)カン/節間/;
  s/ケイカン/茎稈/;
  s/カンチョウ/稈長/;
  s/クサタケ/草丈/;
  s/ハナタケ/花丈/;
  s/ケンビ(ョ|ヨ)ウ/健苗/;
  s/ムレナエ/ムレ苗/;
  s/キズグチ/傷口/;
  s/リソウ/離層/;
  s/シ(ュ|ユ)シ/種子/;
  s/カジツ/果実/;
  s/カヘイ/果柄/;
  s/カメン/果面/;
  s/カボウ/果房/;
  s/カリ(ュ|ユ)ウ/果粒/;
  s/ヒ(ョ|ヨ)ウヒ/表皮/;
  s/ウキカワ|フヒ/浮皮/;
  s/メ(バ|ハ)ナ/雌花/;
  s/オ(バ|ハ)ナ/雄花/;
  s/ハナメ/花芽/;
  s/ハナクビ/花首/;
  s/ハツガ/発芽/;
  s/ホウガ/萌芽/;
  s/ハツライ/発蕾/;
  s/チ(ャ|ヤ)クライ/着蕾/;
  s/チ(ャ|ヤ)クリ(ュ|ユ)ウ/着粒/;
  s/チ(ャ|ヤ)(ッ|ツ)カ/着果/;
  s/ハナ(?=ブ)/花/;
  s/ハナフルイ/花振い/;
  s/カイカ/開花/;
  s/カセイ/花成/;
  s/トウジ(ュ|ユ)ク/登熟/;
  s/カンジ(ュ|ユ)ク/完熟/;
  s/ジ(ュ|ユ)クキ/熟期/;
  s/チ(ャ|ヤ)クシ(ョ|ヨ)ク/着色/;
  s/ラ(ッ|ツ)カ/落果/;
  s/ラクヨウ/落葉/;
  s/トウフク/倒伏/;
  s/セイイク/生育/;
  s/ハ(ッ|ツ)コン/発根/;
  s/カ(ッ|ツ)チ(ャ|ヤ)ク/活着/;
  s/キ(ュ|ユ)ウミン/休眠/;
  s/シンチ(ョ|ヨ)ウ/伸長/;
  s/トチ(ョ|ヨ)ウ/徒長/;
  s/ケイセイ/形成/;
  s/ブンカ/分化/;
  s/ヒダイ/肥大/;
  s/ジ(ョ|ヨ)ウサン/蒸散/;
  s/シ(ョ|ヨ)ウガイ/障害/;
  s/シ(ョ|ヨ)クガイ/食害/;
  s/ヒヤケ/日焼/;
  s/ユゴウ/癒合/;
  s/ソガイ/阻害/;
  s/ケイゲン/軽減/;
  s/ボウシ/防止/;
  s/イクセイ/育成/;
  s/ソクシン/促進/;
  s/タンシュク/短縮/;
  s/ゾウカ/増加/;
  s/アンテイ/安定/;
  s/イジ/維持/;
  s/チ(ョ|ヨ)ウセツ/調節/;
  s/ダハ/打破/;
  s/キヒ/忌避/;
  s/ワイカ/矮化/;
  s/カ繁茂/過繁茂/;
  s/ム種子/無種子/;
  s/種子カ/種子化/;
  return $_;
}

# 剤型
sub actype {
  $_ = $_[0];
  s/ザイ$/剤/;
  s/フン剤/粉剤/;
  s/リ(ュ|ユ)ウ剤/粒剤/;
  s/フン粒剤/粉粒剤/;
  s/スイワ剤/水和剤/;
  s/スイヨウ剤/水溶剤/;
  s/ニ(ュ|ユ)ウ剤/乳剤/;
  s/エキ剤/液剤/;
  s/ユ剤/油剤/;
  s/(燻|クン)(煙|エン)剤/くん煙剤/;
  s/(燻|クン)(蒸|ジ(ョ|ヨ)ウ)剤/くん蒸剤/;
  s/トフ剤/塗布剤/;
  s/(ビリ(ョ|ヨ)ウ)?サンプ剤/微量散布剤/;
  s/ノウヤクヒリ(ョ|ヨ)ウ/農薬肥料/;
  s/フンマツ/粉末/;
  return $_;
}

1;
__END__

# 開発履歴
# 2.5.0 2006/03/30 ファーストリリース
