# 農薬検査所DB用携帯農薬検索システム(サブ CGI)
# 病害虫名かな->漢字変換
# Version 2.5.2 Copyright(C) 2005 Hidemi Oya

$_ = $pn;

# 全般
s/ルイ$/類/;
s/ビ(ョ|ヨ)ウガイ/病害/;
s/(害|ガイ)チ(ュ|ユ)ウ/害虫/;
s/チ(ョ|ヨ)ゾウ/貯蔵/;
s/エ(ッ|ツ)トウ/越冬/;
s/キ(ュ|ユ)ウミン/休眠/;
s/カクセイ/覚醒/;
s/センコウ/セン孔/;
s/ラクヨウ/落葉/;
s/ナエ/苗/;

# 病害
## 接頭語
s/ギジ/疑似/;
## 接尾語
s/(?<!ヨウ)ビ(ョ|ヨ)ウ$/病/;
s/(?<!シン|ヨウ)シ(ョ|ヨ)ウ$/症/;
s/キン$/菌/;
## 態様
s/カメノコウ/亀ノ甲/;
s/カンセイ/乾性/;
s/キレツ/亀裂/;
s/コウヤク/膏薬/;
s/コシ/枯死/;
s/フキ(ュ|ユ)ウ/腐朽/;
s/(フン|コナ)ジ(ョ|ヨ)ウ/粉状/;
## ステージ
s/ヨウ(ビ(ョ|ヨ)ウ|苗)/幼苗/;
s/ヨウカ/幼果/;
## 病名
### 病名接尾語
s/サイ(キン|菌)/細菌/;
s/キンカク/菌核/;
### いもち
s/(葉|ハ|穂|ほ)イモチ/イモチ/; # 病害虫名として「穂いもち病」はあるが、登録農薬がない
### 炭疽
s/タンソ/炭疽/;
### 疫病
s/エキ/疫/;
s/ナツ疫/夏疫/;
### 黒穂
s/クロホ(?!シ)/黒穂\1/;
s/カタ黒穂/堅黒穂/;
s/スミ黒穂/墨黒穂/;
s/ハダカ黒穂/裸黒穂/;
s/(生|ナマ)グサ黒穂/ナマグサ黒穂/;
### その他
s/イ(ネ|ナ)コウジ/稲コウジ/;
s/アカ(コ|ゴ)ロモ/赤衣/;
s/イオウ/萎黄/;
s/イチ(ョ|ヨ)ウ/萎凋/;
s/イシ(ュ|ユ)ク(?!セ)/萎縮/;
s/ウラ(ウドンコ)/裏\1/;
s/エダ(フ|ブ)クレ/枝膨/;
s/カンボツ/陥没/;
s/カン(プ|フ)/乾腐/;
s/ギン(ヨウ|バ)/銀葉/;
s/クウドウ/空胴/;
s/クモ(ガ|カ)タ/雲形/;
s/クロ(ア(ザ|シ))/黒\1/;
s/クロタマ/黒球/;
s/クロネ/黒根/;
s/コク(トウ|シ(ュ|ユ))/黒\1/;
s/黒シユ/黒シュ/;
s/ジ(ュ|ユ)シ/樹脂/;
s/シ(ラ|ロ)キヌ/白絹/;
s/ソウコン/叢根/;
s/ツルワレ/ツル割/;
s/テングス/テング巣/;
s/ナン(プ|フ)/軟腐/;
s/ノビ(?!エ)/野火\1/;
s/バ(ク|ッ)カク/麦角/;
s/ハンヨウ/斑葉/;
s/フハイ/腐敗/;
s/フラン/腐ラン/;
s/ヘンヨウ/変葉/;
s/(?<!ケ)マイ(?!モ|マ)/舞\1/;
s/モウセン/毛セン/;
s/モンパ/紋羽/;
s/ワイカ/ワイ化/;
## 症状
### 折
s/コシオレ/腰折/;
s/エダオレ/枝折/;
### 粒
s/リ(ュ|ユ)ウ/粒/;
### 条
s/カツジ(ョ|ヨ)ウ/褐条/;
s/クロスジ/黒条/;
### 焼
s/(?<!ミ)ヤケ/焼\1/;
### 渋
s/(?<!ア)シブ(?!ト)/渋\1/;
### かび
s/ミドリカビ/緑カビ/;
s/ハイカビ/灰色カビ/;
### さび
s/コサビ/小サビ/;
s/キサビ(?!ダ)/黄サビ/;
### 星
s/(ホ|ボ)シ(?!テ|ク|タ)/星\2/;
### 斑
s/(ハ|パ)ン(?!ミ)/斑/;
s/アミ斑/網斑/;
s/オ斑/汚斑/;
s/カク斑/角斑/;
s/ジ(ョ|ヨ)ウ斑/条斑/;
s/リ(ョ|ヨ)ク斑/緑斑/;
s/リン斑/輪斑/;
s/シ斑/紫斑/;
### 点
s/(?<!タ)テン(?!(サ|ト|グ))/点/;
s/ハン点/斑点/;
### 紋
s/カンモン/環紋/;
s/ガンモン/眼紋/;
s/ススモン/スス紋/;
s/ハンモン/斑紋/;
s/ヒョウモン/ヒョウ紋/;
s/カツモン/褐紋/;
s/リンモン/輪紋/;
### 枯
s/カレ(?!ハ)/枯/;
s/(?<!シン)ガレ/枯/;
s/モン枯/紋枯/;
s/サキ枯/先枯/;
s/タチ枯/立枯/;
s/ドウ枯/胴枯/;
s/フサ枯/房枯/;
s/ホ枯/穂枯れ/;
### 腐
s/(ク|グ)サレ(?!セ)/腐/;
s/ツリ腐/吊腐/; # 「吊り腐れ」は現状で登録農薬なし
s/(ワ|リン)腐/輪腐/;
s/ワタ腐/綿腐/;
s/ニガ腐|クフ/苦腐/;
s/オソ腐|バン(プ|フ)/晩腐/;
s/ハル腐/春腐/;
s/ユキ腐/雪腐/;
s/クビ腐/首腐/;
s/シン腐/心腐/; # 「芯腐れ」は現状で登録農薬なし
s/シリ腐/尻腐/;
s/ミキ腐/幹腐/;
s/ハナ腐/花腐/;
s/ネ腐/根腐/;
## 色
s/シ(ョ|ヨ)ク(?!ヨ)/色/;
s/イイロ(?!サ)/イ色/;
s/(?<!ビ|キ)イロ/色/;
s/(ヘ|ペ)ン/変/;
s/ハ(ク|ッ)カ/白化/;
### 接頭色
s/アオ(カビ|枯)/青\1/;
s/アカ(カビ|サビ|枯|渋|星|焼)/赤\1/;
s/オウ(斑|変|白化)/黄\1/;
s/カ(ツ|ッ)(サビ|点|斑|変|色)/褐\2/;
s/コウ(色|粒)/紅\1/;
s/コク(トウ|粒|斑|点|変)/黒\1/;
s/クロ(カビ|サビ|スス|枯|腐|渋|星)/黒\1/;
s/シ(ロ|ラ)(カビ|サビ|枯|腐|星|紋羽)/白\2/;
s/セキ(斑|色)/赤\1/;
s/ハク(点|斑|色)/白\1/;
s/ハイ(斑|星|色)/灰\1/;
s/ムラサキ(紋羽)/紫\1/;
### 色接尾語
s/(変|色)マイ/米/;
## 部位
s/カライ/花蕾/;
s/カジツ/果実/;
s/キ(ュ|ユ)ウコン/球根/;
s/コンケイ/根茎/;
s/コントウ/根頭/;
s/シンシ(ョ|ヨ)ウ/新梢/;
s/センタン/先端/;
s/ナイエイ/内穎/;
s/ハンシン/半身/;
s/ヨウシ(ョ|ヨ)ウ/葉鞘/;
s/リンケイ/鱗茎/;
s/リン(ペ|ヘ)ン/リン片/;
### 接頭部位
s/エダ(軟腐|枯)/枝\1/;
s/カブ(枯|腐)/株\1/;
s/クキ(疫|枯|腐)/茎\1/;
s/ネ(クビレ|コブ(?!セ)|黒斑)/根\1/;
s/ハ(カビ|スス|フルイ|枯|腐|渋|炭疽|焼)/葉\1/;
s/ミ(褐斑|腐|炭疽)/実\1/;
s/メ(枯|腐)/芽\1/;
### 部位接頭色
s/クロ(葉)/黒\1/;
s/シ(ラ|ロ)(葉)/白\2/;
## 形状・サイズ
s/シ(ョ|ヨ)ウ(粒|菌核|黒点)/小\2/;
s/マル(星|斑)/円\1/;

# 害虫
s/^キ(ュ|ユ)ウシ(ュ|ユ)ウ/吸収/;
s/ガイジ(ュ|ユ)ウ/害獣/;
s/ノ(ウサギ)/野\1/;
s/ノネズミ|ヤソ/野ソ/;
s/セイチ(ュ|ユ)ウ/成虫/;
s/ヨウ(ュ|ユ)/幼虫/;
s/コウ(ュ|ユ)/甲虫/;
s/(?<!オ)オス/雄/;
s/ジ(ャ|ヤ)クレイ/若齢/;
s/ホウカ/訪花/;
s/スリ(ッ|ツ)プ(ス)?/アザミウマ/;
s/イチモンジセセリ/イネツトムシ/;
s/イネアオムシ/フタオビコヤガ/;

# 雑草
s/ザ(ッ|ツ)ソウ/雑草/;
s/スイデン/水田/;
s/ハタチ/畑地/;
s/ケイハン/畦畔/;
s/コハン/湖畔/;
s/ネンセイ/年生/;
s/イチ年生/一年生/;
s/タ年生/多年生/;
s/(イネ)カ/\1科/;
s/(カヤツリグサ)カ/\1科/;
s/(キク)カ/\1科/;
s/(タデ)カ/\1科/;
s/(ヒルガオ)カ/\1科/;
s/(マメ)カ/\1科/;
s/ソウ類/藻類/;
s/タケ類/竹類/;
s/イ(ッ|ツ)パン/一般/;
s/コウヨウ|ヒロハ/広葉/;
s/ジ(ョ|ヨ)ウリ(ョ|ヨ)ク/常緑/;
s/ソウホン/草本/;
s/ツルセイ/ツル性/;
s/シタクサ/下草/;
s/ザ(ツ|ッ)カンボク/雑カン木/;
s/ザツボク|ゾウキ/雑木/;

# 植調剤
s/ショクチョウザイ/植調剤/;
s/カッチャク/活着/;
s/キズグチ/傷口/;
s/ケイゲン/軽減/;
s/セイイク/生育/;
s/セ(ツ|ッ)カン/節間/;
s/ソガイ/阻害/;
s/ソクシン/促進/;
s/タンシュク/短縮/;
s/トウジュク/登熟/;
s/トウフク/倒伏/;
s/ハ(ッ|ツ)コン/発根/;
s/ボウシ/防止/;
s/ユゴウ/ユ合/;

# 全般接尾語
s/(立枯|吸収)セイ/\1性/;

$pn = $_;

1;
__END__

# 開発履歴
# 2.5.0 2005/10/26 ファーストリリース
# 2.5.1 2005/11/19 フタテン、テントウ等漢字変換してはいけない「テン」を「点」に変換していたバグを修正
#                  ショウリュウ、ショウキンカク等を「小ョ」と誤変換していたバグを修正
#                  コクトウを「黒トウ」に変換できないバグを修正
#                  シラハガレを「白ラ枯」と誤変換していたバグを修正
#                  サイキンを「サイ菌」と誤変換していたバグを修正
#                  「ネコブセンチュウ」を「根コブセンチュウ」と変換していたバグを修正
#                  「スリップス」を「アザミウマ」の別名として登録
# 2.5.2 2005/12/06 「イチモンジセセリ」を「イネツトムシ」の別名として登録
#                  「イネアオムシ」を「フタオビコヤガ」の別名として登録
