# 農薬検査所DB用携帯農薬検索システム(サブ CGI)
# 適用表(vtllg103.do)用出力変換
# Version 2.5.2 Copyright(C) 2004-2006 Hidemi Oya

use tm;

&regularize('<table'); # 受信データ整形

# 出力画面テンプレート読み込み
&readtemp;

# 受信結果をテーブルごとに分割
my @tabs = split(/<table[^>]*>/i, $body);
my $tab;
my @tr;

# 適用表より前にあるテーブルの出力フォーマットの設定
my $blockid = '<!--begin_cond-->(.+?)<!--end_cond-->';
&syserr('農薬概要出力書式がありません') if (! /$blockid/i);
my $format = $1;
# 適用表より前にあるテーブルの処理
my $res = ''; # 結果保存変数の初期化
while ($tabs[0] !~ m|適用表</caption|i) { # <CAPTION> が「適用表」になるまで実行
  $tab = shift(@tabs); # テーブルを抜き出す
  $tab =~ s|(</td>)(<th ?[^>]*)|\1</tr><tr>\2|ig; # <TR></TR> 内のデータ正規化
  @tr = split(/<tr ?/i, $tab); # <TR> タグごとに切り出し
  shift(@tr); # 先頭のゴミを削除
  foreach $d (@tr) {
    $d =~ m|<th ?[^>]*>(.+?)</th>|i; # <TH> タグの内容を切り出し
    my $item = $1;
    $d =~ m|<td ?[^>]*>(.+?)</td>|i; # <TD> タグの内容を切り出し
    my $text = $1;
    $text = &google($text) if (index($item, '農薬の') >= 0);  # 項目名に '農薬の' が含まれる場合 Google 検索可能にする
    eval('$res .= "'.$format.'"'); # 検索条件各項目の整形
  }
}
s/$blockid/$res/i;

# 適用表出力フォーマットの設定
$blockid = '<!--begin_hanrei-->(.+?)<!--end_hanrei-->';
&syserr('適用出力書式がありません') if (! /$blockid/i);
my $format1 = $1;
$blockid = '<!--begin_naiyo-->(.+?)<!--end_naiyo-->';
&syserr('適用出力書式がありません') if (! /$blockid/i);
my $format2 = $1;
$blockid = '<!--begin_tekiyo-->(.+?)<!--end_tekiyo-->';
&syserr('適用出力書式がありません') if (! /$blockid/i);
$format = $1;
&dataerr('適用表がありません') if ($tabs[0] !~ m|適用表</caption|i);
$res = '';

# 作物名の取得
my @cn = ();
if (my $cv = $sm->param('cv')) {
  my $k101 = $sm->param('k101');
  my $code = substr($cv, 0, 2).'00000000';
  unshift(@cn, $1) if ($k101 =~ /,'$code','([^']+)/); # 大分類名取得
  if ($cv ne $code) { # $cv が大分類でない場合
    $code = substr($cv, 0, 4).'000000';
    unshift(@cn, $1) if ($k101 =~ /,'$code','([^']+)/); # 中分類名取得
    if ($cv ne $code) { # $cv が中分類でない場合
      my $ucode = $code;
      $code = substr($cv, 0, 6).'0000';
      if ($ucode ne $code) { # 中分類コードと小分類コードが異なる場合
        unshift(@cn, $1) if ($k101 =~ /,'$code','([^']+)/); # 小分類名取得
      }
      if ($cv ne $code) { # $cv が小分類でない場合
        $code = substr($cv, 0, 8);
        my @crops = split(/\+/, $k101);
        shift(@crops); # ゴミ削除
        foreach $crop (@crops) { # 全作物名取得
          if ($crop =~ /,'$code[0-9][0-9]','([^']+)/) {
            my $tcn = $1;
            unshift(@cn, $tcn) if (index($tcn, '（') < 0); # （）を含まない作物名のみ取得
          }
        }
      }
    }
  }
}
# 病害虫名等／使用目的の取得
my $pn = '';
my $up = '';
$pn = $1 if ($sm->param('g303') =~ /name=byg\[0\]\.label value=([^>]*)/i);
$pn = '' if (($pn eq '""') || ($pn eq "''"));
$up = $1 if ($sm->param('g303') =~ /name=syh_mk_name value=([^>]*)/i);
$up = '' if (($up eq '""') || ($up eq "''"));
# 適用表テーブルの処理
my $tno = 1; # 表示適用表数
my $target = ''; # 適用対象項目名
while (@tabs) {
  my @rows = ();
  my @text = ();
  my $notes = '';
  my $apply = '';
  my $form1 = $format1;
  my $form2 = $format2;
  my $icn = 0;
  $tab = shift(@tabs); # テーブルを抜き出す
  @tr = split(/<tr ?/i, $tab); # <TR> タグごとに切り出し
  shift(@tr); # 最初のゴミを読み飛ばし
  # 先頭の <TH> タグで表のカラム数を設定
  my @td = split(/<th ?/i, shift(@tr)); # <TH> タグごとに切り出し
  shift(@td); # 最初のゴミを読み飛ばし
  my @cols = ();
  while ($d = shift(@td)) {
    if ($d =~ /colspan=([0-9]+)/i) { # colspan が設定されている場合
      my $c = $1; # 列数保存
      if ($c > 1) { # $c が２以上の場合
        if (!@cols) { # 次の <TR> ブロック存在しない場合
          @cols = split(/<th ?/i, shift(@tr)); # 次の <TR> ブロックを取得して <TH> タグごとに切り出し
          shift(@cols); # 最初のゴミを読み飛ばし
        }
        while ($c > 1) { # 次の <TR> ブロックの <TH> を列数－１分だけ @td に unshift する
          unshift(@td, splice(@cols, --$c));
        }
        $d = shift(@cols);
      }
    }
    push(@rows, 1); # $rows[x] を初期化
    $d =~ /[^>]*>([^<]+)/;
    my $s = $1;
    # 有効成分名に再検索のリンクを張る
    if ($s =~ /(.+?)(を含む農薬の総使用回数)/) {
      my @k = split(/\s/, $1);
      $s = "<A href=$uri&ak=$k[0]&up=&an=&at=&pv=>$1</A>$2";
    }
    push(@text, $s);
    $icn = @text - 1 if ($s eq '作物名'); # 作物名の項目番号を保存
  }
  # 作物名の次の項目名が「使用目的」なら $pn に $up の内容を設定
  $pn = $up if (index($text[$ich + 1], '目的') > 0);
  $form1 =~ s|(^.+\$text\[$#rows\](</.+?>)*?).*(</.+?>$)|\1\3|i; # 書式を rows 数まで短縮
  $form2 =~ s|(^.+\$text\[$#rows\](</.+?>)*?).*(</.+?>$)|\1\3|i; # 書式を rows 数まで短縮
  eval('$notes .= "'.$form1.'"');
  # 有効成分ごとの総使用回数表かどうかのチェック
  my $fcount = 1; # 総使用回数表フラッグ
  foreach $d (@text) { # 全項目名に「総使用回数」が入っていれば総使用回数表
    $fcount &= (index($d, '総使用回数') >= 0);
  }
  # 適用データの設定
  foreach $tr (@tr) {
    @td = split(/<td ?/i, $tr); # <TD> タグごとに切り出し
    shift(@td); # 最初のゴミを読み飛ばし
    # 項目データの取得
    for (my $i = 0; $i <= $#rows; $i++) {
      $rows[$i]--;
      next if ($rows[$i]);
      my $d = shift(@td);
      $d =~ /rowspan=([0-9]+)/i;
      my $n = $1;
      $n = 1 if (! $n);
      $rows[$i] = $n;
      $d =~ /[^>]*>([^<]+)/;
      $text[$i] = $1;
    }
    # 指定した適用作物等かどうかのチェック
    my $fcrop = 1; # 適用作物フラッグ
    my $s = $jc->set($text[$icn], 'utf8')->h2z->utf8;
    foreach $crop (@cn) {
      $crop =~ s/(（.+?）)/\(\1\)\?/; # （）を含む作物名は（）が無くてもマッチするように修正
      $crop =~ s/(・.+)/\(\1\)\?/; # ・を含む作物名は・以降が無くてもマッチするように修正
      last if ($fcrop = $s =~ /(^|、)$crop(、|（|$)/); # 指定作物にマッチすればループ終了
    }
    if ($fcrop && (index($s, 'を除く）') >= 0)) { # 作物名に 'を除く）' が存在する場合
      foreach $crop (@cn) {
        last if (!($fcrop = $s !~ /(（|、)$crop(、.+?)*を除く）/)); # 指定作物を除くにマッチするならループ終了
      }
    }
    # 指定した適用病害虫等／使用目的かどうかのチェック
    my $fpest = 1; # 適用病害虫等／使用目的フラッグ
    $fpest = (index($jc->set($text[$icn + 1], 'utf8')->h2z->utf8, $pn) >= 0) if ($pn);
    # 現在の適用表整形
    if ($fcount || ($fcrop && $fpest)) {
      eval('$apply .= "'.$form2.'"');
    }
  }
  # 全適用表整形
  if ($apply) {
    $res .= $notes.$apply;
    $tno++;
  }
}
if ($res) {
  s/<!--begin_hanrei-->(.+?)<!--end_naiyo-->/$res/i;
} else {
  s/$blockid/該当する適用がありません/i;
}

1;
__END__

# 開発履歴
# 1.0.0 2004/12/22 ファーストリリース
# 1.0.1 2005/04/07 表示切替ボタン書換部分削除
# 1.1.0 2005/04/18 凡例を最初に表示するように変更
#                  上位分類の適用が表示されないバグを修正
#                  項目番号を「作物名=0」「病害虫名=1」に固定していたバグを修正
# 1.2.0 2005/05/13 作物名検索で取得される作物名と適用表で表示される作物名で括弧の全角／半角が異なる場合に対応
#                  農薬一覧で農薬を選択すると適用表が表示されるように変更
#                  受信パラメータ変数の変更に対応
#                  $cl の $cn への統合に対応
# 1.3.0 2005/05/21 指定作物のみ表示する(「ねぎ」で「たまねぎ」まで表示しない)よう変更
#                  有効成分ごとの総使用回数別表を表示するように変更
#                  有効成分名による再検索機能を追加
# 2.0.0 2005/05/26 エラー処理の変更に対応
#                  キャリア別テンプレート読み込み機能に対応
#                  作物名・病害虫名等を受信ファイルから取得するよう変更
#                  データソース表示機能に対応
#                  内部処理の文字コードを UTF8 に変更
# 2.0.1 2005/07/06 「（○○を除く）」の○○に該当する作物を表示しないように変更
# 2.0.2 2005/09/27 作物名／病害虫名を g303 セッションデータから読んでいなかったバグを修正
# 2.5.0 2005/10/26 データ整形処理追加
#                  正規表現単純化と可能な場合は index 関数に変更
#                  詳細作物名でマッチした適用を表示できなかったバグを修正
# 2.5.1 2005/11/04 表頭が２行にまたがっている適用表を表示できないバグを修正
# 2.5.2 2005/11/17 「花き類（草本植物）・観葉植物」のように「（○○）」や「・」を含む作物名で検索したときに、（）抜きや・より前までの作物名で登録された適用が表示できないバグを修正
#       2006/03/30 使用目的検索に対応
#                  適用の凡例と内容を別途処理するように変更
