# 農薬検査所DB用携帯農薬検索システム(サブ CGI)
# 登録農薬一覧(vtllg303.do)用出力整形
# Version 2.5.1 Copyright(C) 2004-2005 Hidemi Oya

use tm;

&regularize('<input'); # 受信データ整形

# 出力画面テンプレート読み込み
&readtemp;
# 分類方法ラジオボタンチェック
if ($gt) {
  s/>(種類)/ checked>\1/;
} else {
  s/>(通称)/ checked>\1/;
}

# 検索条件出力フォーマットの設定
my $blockid = '<!--begin_cond-->(.+?)<!--end_cond-->';
&syserr('検索条件出力書式がありません') if (! /$blockid/i);
my $format = $1;
my $reg = '';
my $type = '';
# 検索条件テーブルの処理
&dataerr('検索条件がありません') if ($body !~ m|検索条件</caption>(.+?)</table>|i);
my $tab = $1; # テーブルを抜き出す
my @tr = split(/<tr ?/i, $tab); # <TR> タグごとに切り出し
shift(@tr); # 先頭のゴミを削除
# <TR> タグごとの整形
my $res = ''; # 結果保存変数の初期化
my $item = '';
my $text = '';
foreach $d (@tr) {
  $d =~ m|<th ?[^>]*>(.+?)</th>|i; # <TH> タグの内容を切り出し
  $item = $1;
  $d =~ m|<td ?[^>]*>(.+?)</td>|i; # <TD> タグの内容を切り出し
  $text = $1;
  if ($item eq '登録の有無') { # 「登録の有無」は読み飛ばし(macs for acis 1.1.0 以降は不要)
    $reg = $text;
    next;
  }
  $type = $text if ($item eq '剤型');
  eval('$res .= "'.$format.'"'); # 検索条件各項目の整形
}
s/$blockid/$res/i; # 検索条件の整形

# 登録農薬一覧テーブルの処理
my %acs = (); # 農薬一覧保存変数
&dataerr('登録農薬一覧がありません') if ($body !~ m|登録農薬一覧</caption>(.+?)</table>|i);
$tab = $1; # テーブルを抜き出す
@tr = split(/<tr ?/i, $tab);# <TR> タグごとに切り出し
shift(@tr); # 先頭のゴミを削除
# <TR> タグごとの整形
foreach $d (@tr) {
  next if ($d =~ m|<th ?[^>]*>|i); # <TH> タグ読み飛ばし
  next if ($reg && (index($d, $reg) < 0));   # 「登録の有無」が条件に合致しない場合は読み飛ばし
  next if ($type && (index($d, $type) < 0)); # 「剤型」が条件に合致しない場合は読み飛ばし
  # <TD> タグ切り分け処理
  $d =~ m|<td ?[^>]*>(.+?)</td><td ?[^>]*>(.+?)</td><td ?[^>]*>(.+?)</td>|i;
  my $rno   = $1;  # 登録番号
  my $group = $2; # 農薬の種類
  my $name  = $3; # 農薬の名称
  $group = tm->cut($name) if (!$gt); # 屋号抜き農薬名
  $rno =~ s/\D*(\d+).*/\1/; # 登録番号から数字以外を削除
  push(@{$acs{$group}}, {rno => $rno, name => $name}); # 検索農薬を変数に保存
}

# 登録農薬一覧出力フォーマットの設定
$blockid = '<!--begin_list-->(.+?)<!--end_list-->';
&syserr('農薬一覧出力書式がありません') if (! /$blockid/i);
# 農薬の種類の出力フォーマット設定
&syserr('農薬の種類出力書式がありません') if (! /<!--begin_group-->(.+?)<!--end_group-->/i);
my $frmgroup = $1;
# 代表農薬の名称の出力フォーマット設定
&syserr('代表農薬の名称出力書式がありません') if (! /<!--begin_typify-->(.+?)<!--end_typify-->/i);
my $frmtypify = $1;
# 通常農薬の名称の出力フォーマット設定
&syserr('農薬の名称出力書式がありません') if (! /<!--begin_data-->(.+?)<!--end_data-->/i);
my $frmdata = $1;
$res = ''; # 結果保存変数の初期化
foreach $group (sort keys %acs) {
  next if ($ag && ($group ne $ag));
  my $count = @{$acs{$group}}; # この種類の登録農薬数を設定
  my $gfrm = $frmgroup;
  my $dfrm = $frmtypify;
  if ($ag || ($count == 1)) { # グループが設定されているか農薬数が 1 の場合
    $gfrm =~ s|</?A ?[^>]*>||ig; # グループのリンクを解除
    $dfrm = $frmdata; # 農薬の名称の出力書式を一般農薬に設定
  }
  if ($gt || ($count > 1)) { # 農薬の種類によるグルーピングまたは農薬数が 2 以上の場合
    my $encgrp = $group;
    $encgrp =~ s/(\W)/'%'.unpack('H2', $1)/eg; # グループ名をエンコード
    eval('$res .= "'.$gfrm.'"'); # グループの整形
  }
  foreach $i (@{$acs{$group}}) {
    my $rno = $$i{'rno'}; # 登録番号
    my $name = $$i{'name'}; # 農薬の名称
    eval('$res .= "'.$dfrm.'"'); # 農薬の名称の整形
    last if (!$ag); # グループが未設定なら代表農薬だけ表示
  }
}
s/$blockid/$res/i; # 登録農薬一覧の整形

1;
__END__

# 1.0.0 2004/12/22 ファーストリリース
# 1.0.1 2005/04/07 検索条件に登録の有無・剤型が存在しない場合に農薬一覧が表示されないバグを修正
# 1.1.0 2005/04/18 農薬一覧表示方法変更、表示切替ボタン書換部分削除
#                  作物分類・作物名を次のパラメータとして渡すように変更
# 1.2.0 2005/05/13 受信パラメータ変数の変更に対応
#                  $cl の $cn への統合に対応
# 2.0.0 2005/05/26 エラー処理の変更に対応
#                  キャリア別テンプレート読み込み機能に対応
#                  データソース表示機能に対応
#                  代表農薬の区分表示機能追加
#                  農薬グループを選択したときのみグループ展開するように変更
#                  内部処理の文字コードを UTF8 に変更
# 2.5.0 2005/10/26 データ整形処理追加
#                  正規表現単純化と可能な場合は index 関数に変更
#                  屋号抜き農薬名による分類機能を追加
# 2.5.1 2005/11/04 tm.pl のモジュール化に伴う変更
