# 農薬検査所DB用携帯農薬検索システム(サブ CGI)
# 農薬登録票(vtllg304.do)用出力変換
# Version 2.5.1 Copyright(C) 2004-2005 Hidemi Oya

# Google 複合検索
sub ggl {
  my $kw1 = shift;
  my @kw2 = ('薬害', '作用', '注意');
  my $res = '';
  foreach $kw (@kw2) {
    $res .= ' '.&google($kw1, $kw);
  }
  return(substr($res, 1));
}

use tm;

&regularize('<table'); # 受信データ整形

# 出力画面テンプレート読み込み
&readtemp;

# 検索条件出力フォーマットの設定
my $blockid = '<!--begin_data-->(.+?)<!--end_data-->';
&syserr('登録票出力書式がありません') if (! /$blockid/i);
my $format = $1;

# 農薬登録票テーブルの処理
&dataerr('農薬登録票がありません') if ($body !~ m|農薬登録票</caption>(.+?)</table>|i);
my $tab = $1; # テーブルを抜き出す
$tab =~ s|(</td>)(<th ?[^>]*)|\1</tr><tr>\2|ig; # <TR></TR> 内のデータ正規化
my @tr = split(/<tr ?[^>]*>/i, $tab); # <TR> タグごとに切り出し
shift(@tr); # 先頭のゴミを削除
# <TR> タグごとの整形
my $gglname;
my $gglkind;
my $res = ''; # 結果保存変数の初期化
foreach $d (@tr) {
  next if ($d =~ /適用/);
  $d =~ s|</tr>||i;
  $d =~ m|<th ?[^>]*>(.+?)</th>|i;
  my $item = $1;
  $d =~ m|<td ?[^>]*>(.+?)</td>|i;
  my $text = $1;
  if (index($item, '農薬の') >= 0) { # 項目名に '農薬の' が含まれる場合
    $gglname = &ggl(tm->cut($text)) if (index($item, '名称') >= 0); # $name に名称を設定
    $gglkind = &ggl($text) if (index($item, '種類') >= 0); # $kind に名称を設定
    $text = &google($text); # Google 検索可能にする
  }
  if (index($item, '氏名又は名称') >= 0) { # 登録者の Google 検索を可能にする
    $text =~ s/(.+?<BR>)(.+)/$1.&google("$2")/ie;
  }
  eval('$res .= "'.$format.'"'); # 検索条件各項目の整形
}
s/$blockid/$res/i;

# Google 検索の設定
s/\$gglname/$gglname/i;
s/\$gglkind/$gglkind/i;

1;
__END__

# 開発履歴
# 1.0.0 2004/12/22 ファーストリリース
# 1.1.0 2005/05/13 農薬一覧で農薬を選択すると適用表が表示されるように変更
#                  受信パラメータ変数の変更に対応
# 1.2.0 2005/05/21 登録者の Google 検索機能を追加
# 2.0.0 2005/05/26 エラー処理の変更に対応
#                  キャリア別テンプレート読み込み機能に対応
#                  データソース表示機能に対応
#                  内部処理の文字コードを UTF8 に変更
# 2.5.0 2005/10/26 データ整形処理追加
#                  正規表現単純化と可能な場合は index 関数に変更
#                  通称名／種類と '薬害', '作用', '' の複合 Google 検索機能追加
# 2.5.1 2005/11/04 tm.pl のモジュール化に伴う変更
