# 農薬検査所DB用携帯農薬検索システム(サブ CGI)
# 病害虫・雑草一覧(vtllk102.do)用出力変換
# Version 2.5.0 Copyright(C) 2005 Hidemi Oya

&stripmenu; # 受信データ整形
# $body =~ s/\+Menu\([^']+'[a-z]*?folder','[^']+'\)//ig;

# 出力画面整形
&readtemp; # テンプレート読み込み
# バック URI が不要なら削除
s/<!--begin_backuri-->.*?<!--end_backuri-->// if (!$pg);
# 入力語／検索語表示
my $epn = $sm->param('epn');
if ($epn ne $pn) { #  # 入力語と検索語が異なる場合
  s/\$epn/$epn/i; # 入力語を表示
} else { # # 入力語と検索語が同じ場合
  s/<!--begin_entered_word-->.*?<!--end_entered_word-->//; # 入力語表示部分を削除
}
s/\$pn/$pn/i; # 検索語を表示

# 病害虫・雑草名の取得
my @classes = split(/\+Menu/i, $body);
my $code;
my $name;
my $id;
my %pests = ();
foreach $class (@classes) {
  next if ($class !~ /\,'([0-9]+)'\,'([^']+)/);
  $code = $1;
  $name = $2;
  # 「、」「除く」「Ｇ」を含む病害虫名等及び害虫グループ名はスキップ
  next if ($name =~ /、|除く|Ｇ$/);
  $id = substr($code, 0, 6);
  $pests{$id}{$code} = $name;
}
&dataerr('該当する病害虫名等がありません', '検索エラー') if (!%pests);

# 病害虫・雑草一覧出力フォーマットの設定
my $blockid = '<!--begin_list-->(.+?)<!--end_list-->';
&syserr('病害虫名等一覧出力書式がありません') if (! /$blockid/i);
# 病害虫・雑草グループの出力フォーマット設定
&syserr('病害虫名等グループ出力書式がありません') if (! /<!--begin_group-->(.+?)<!--end_group-->/i);
my $frmgroup = $1;
# 病害虫・雑草個別データの出力フォーマット設定
&syserr('病害虫名等個別データ出力書式がありません') if (! /<!--begin_data-->(.+?)<!--end_data-->/i);
my $frmdata = $1;

# 病害虫・雑草一覧の作成
my $res = ''; # 結果保存変数の初期化
foreach $id (sort keys %pests) {
  next if ($pg && ($pg ne $id)); # $id と $pg が一致しなければスキップ
  my $i = 0;
  foreach $code (sort keys %{$pests{$id}}) {
    $name = $pests{$id}{$code};
    my $count = keys(%{$pests{$id}});
    if (!$pg && !$i && ($count > 1)) {
      eval('$res .= "'.$frmgroup.'"'); # 病害虫・雑草のヘッダの整形
    } else {
      eval('$res .= "'.$frmdata.'"'); # 病害虫・雑草名の整形
    }
    last if (!$pg); # $pg が設定されてなければループ終了
    $i++;
  }
}
s/$blockid/$res/i; # 病害虫・雑草一覧の整形

1;
__END__

# 開発履歴
# 1.0.0 2005/04/07 ファーストリリース
# 1.1.0 2005/04/18 病害虫名等一覧表示方法変更
#                  該当病害虫名等が存在しない場合のエラー処理追加
# 1.1.1 2005/04/24 setquery 関数の仕様変更に対応
# 1.1.1 2005/04/24 setquery 関数の仕様変更に対応
# 1.2.0 2005/05/13 グループ展開時に病害虫名一覧に戻る機能を追加
#                  受信パラメータ変数の変更に対応
# 1.2.1 2005/05/21 害虫グループ名及び「、」「除く」を含む病害虫名等は非表示に変更
# 2.0.0 2005/05/26 エラー処理の変更に対応
#                  キャリア別テンプレート読み込み機能に対応
#                  データソース表示機能に対応
#                  内部処理の文字コードを UTF8 に変更
# 2.5.0 2005/10/26 データ整形処理追加
#                  正規表現単純化と可能な場合は index 関数に変更
#                  検索語表示機能追加(自動かな漢字変換機能への対応)
