# 農薬検査所DB用携帯農薬検索システム(サブ CGI)
# 登録農薬一覧(vtllg303.do)用送出パラメータ処理
# Version 2.5.1 Copyright(C) 2004-2006 Hidemi Oya

require "dic$pi.pl";

# セッションデータ初期化等
my $flush = 0;
if ($usedic) { # 自動かな漢字変換使用の場合
  $sm->param('ad', $ad); # 自動かな漢字変換オプション保存
  $flush = 1;
  $ad = $ad && $usedic;
}
if (defined($up)) { # 使用目的が指定されていればセッションに保存
  $up = &dic::purpose($up) if ($up && $ad);
  if ($up ne $sm->param('up')) {
    $sm->param('up', $up);
    $flush = 1;
  }
} else { # 指定されてなければセッションから読み込み
  $up = $sm->param('up');
}
if (defined($an)) { # 農薬の名称が指定されていればセッションに保存
  $an = &dic::actype($an) if ($an && $ad);
  if ($an ne $sm->param('an')) {
    $sm->param('an', $an);
    $flush = 1;
  }
} else { # 指定されてなければセッションから読み込み
  $an = $sm->param('an');
}
if (defined($ak)) { # 農薬の種類が指定されていればセッションに保存
  $ak = &dic::actype($ak) if ($ak && $ad);
  if ($ak ne $sm->param('ak')) {
    $sm->param('ak', $ak);
    $flush = 1;
  }
} else { # 指定されてなければセッションから読み込み
  $ak = $sm->param('ak');
}
if (defined($at)) { # 剤形が指定されていればセッションに保存
  if ($at ne $sm->param('at')) {
    $sm->param('at', $at);
    $flush = 1;
  }
} else { # 指定されてなければセッションから読み込み
  $at = $sm->param('at');
}
if (defined($pv) && !$pv) { # 農薬の種類・名称／有効成分による再検索なら病害虫コードをクリア
  $sm->clear('pv');
  $flush = 1;
}
if (defined($cv) && !$cv) { # 農薬の種類・名称／有効成分による再検索なら作物コードをクリア
  $sm->clear('cv');
  $flush = 1;
}
$sm->clear($pi) if ($flush); # ここまでで $flush が真なら g303 受信データを棄却
if (defined($gt)) { # 分類方法が指定されていればセッションに保存
  $sm->param('gt', $gt);
  $flush = 1;
} else { # 指定されていなければセッションから読み込み
  $gt = $sm->param('gt');
}
$sm->flush if ($flush);

# 入力項目チェック
if ($sm->param('cv').$sm->param('pv').$an.$ak.$up eq '') {
  &dataerr('作物名/病害虫名/使用目的/農薬の名称/農薬の種類のいずれかひとつを入力してください', '送信データエラー');
}

### サーバサイド CGI パラメータの設定
my $pv = $sm->param('pv');
# 一括設定
%PARAMS = (
  # 必須パラメータ
  'currentPage' => '1',
  'trk_date.year' => '', 'trk_date.month' => '', 'trk_date.day' => '',
  'yuko_date.year' => '', 'yuko_date.month' => '', 'yuko_date.day' => '',
  # 検索条件パラメータ
  'syh_mk_name' => $up,
  'skmt[0].value' => $sm->param('cv'), 'byg[0].value' => $pv,
  'nyk_syu_name' => $ak, 'nyk_name' => $an, 'zai.value' => $at
);
# 病害虫等名称
$PARAMS{'byg[0].label'} = &getname('pest') if ($pv);
# 剤形名称
if ($at ne '') {
  &readtemp('sa');
  m|<select name=at>(.+?)</select>|i; # 剤型のリスト取得
  my $opt = $1;
  $opt =~ /value=$at>([^<]*)/i;
  $PARAMS{'zai.label'} = $1;
}

1;
__END__

# 開発履歴
# 1.0.0 2004/12/22 ファーストリリース
# 1.0.1 2005/04/18 vtllg303.do のみに必要なパラメータをこのサブ CGI で設定するよう変更
# 1.1.0 2005/05/13 受信パラメータ変数の変更に対応
#                  setparam 関数の変更に対応
# 2.0.0 2005/05/26 サーバサイドセッションに対応
#                  剤形名称取得でキャリア別テンプレート読み込み機能に対応
#                  setparam 関数の変更に対応
#                  エラー処理の変更に対応
#                  適用表からの農薬の種類による再検索に対応
#                  内部処理の文字コードを UTF8 に変更
# 2.0.1 2005/09/27 セッションデータクリア方法変更
# 2.5.0 2005/10/26 正規表現の単純化
#                  屋号抜き農薬名による分類機能に対応
# 2.5.1 2006/03/30 使用目的検索に対応
