# 農薬検査所DB用携帯農薬検索システム(サブ CGI)
# 屋号リスト
# Version 2.5.3 Copyright(C) 2005-2006 Hidemi Oya

package tm;

# 屋号リスト
my $list = 
  'ＡＣＣ|ＢＡＳＦ|ＤＡＳ|ＤＩＣ|Ｆ．Ｇ．|ＦＭＣ|ＧＦ|ＨＣＣ|ＩＣ(Ｉ)?|'.
  'ＪＡ|ＪＣ|ＳＤＳ|ＳＴ|ＴＧ|ＴＭ|ＵＢＥ|'.
  'アグロス(?!リン|ター)|イヅツ(ヤ)?|カダン(?=泡)|カヤク|^キング(?!ダム|スタ)|'.
  'クミアイ|クレハ|コープケミカル|サイアナミッド|サンケイ|シオノギ|'.
  'シンジェンタ|ゼネカ|タケダ|チバガイギー|デュポン|トクソー|トクヤマ|トモノ|'.
  'ナガセ|ノバルティス|ハース|バイエル|ファイザー|フマキラー|ホドガヤ|'.
  'ホクコー|ミカサ|モンサント|ヤシマ|ユーピーエル|ローヌ・プーラン|'.
  '旭|石原|一農|井筒屋|出光|永光|大塚|科研|兼商|協友|協和|金鳥|興農|三光|三共|'.
  '三明|昭和|信越|新富士|住化|住商|住友(化学)?|双商|武田|東ソー|南海|日農|'.
  '日産|日曹|日本化薬|菱商|細井|丸紅|丸和|三井(東圧)?|三菱(油化)?|明治|理研';

## 石灰硫黄合剤専門
#  'カネナカ|ヤナイ|海野|塩山|宮内|余市組合|'.
## 石灰窒素専門
#  'エス・カ・ベー|クニ|軍配|'.
## 生石灰専門(マルカはライト、ＰＧＰがあるがいずれも１社のみ)
#  'アトミロン|オキヤマタ|カネジュウ|カネタ|サメコウ|マルイゲタクン|マルカ|'.
#  'マルキタ|マルキチ|マルコ|マルジョウ|マルタ|マルヤマ|マルワイ|ヤマタ|'.
#  'ヤマニ|共石|上州石灰|田中|菱|丸京|'.
## 硫酸銅専門(マルアは硫酸亜鉛もあるが１社のみ、蛇の目は丹礬だが１社のみ)
#  'エルピー|マルア|小名浜|蛇の目|'.

# 屋号削除
sub cut {
  my $t = $_[1];
  # 「硫酸銅」「(粉末)生石灰」「石灰硫黄合剤」「石灰窒素」「エムダイファー」の前を削除
  $t =~ s/^.*?(硫酸銅|(粉末)?生石灰|石灰硫黄合剤|石灰窒素|エムダイファー)/\1/;
  $t =~ s/(家庭)?園芸(用)?|産業//; # 「(家庭)園芸(用)」「産業」削除
  $t =~ s/（.*?）$//; # 末尾括弧を削除
  $t =~ s/防散/\1/; # 「防散」を削除
  $t =~ s/(「|［|〔)?($list)(〕|］|」)?(　|印|・|の|－)?//; # 屋号と接尾語を削除
  return $t;
}

1;
__END__

# 開発履歴
# 2.5.0 2005/10/26 ファーストリリース
# 2.5.1 2005/11/04 モジュールに変更
#                  屋号接尾語に '　', '－' を追加
#                  硫酸銅、生石灰、石灰硫黄合剤、石灰窒素の認識方法を変更
#                  上記農薬専門メーカーをリストから削除
#                  下記屋号を追加(Thanks kabe!)
#                    ＡＣＣ、ＧＦ、ＨＣＣ、ＪＡ、ＴＧ、ＴＭ、サイアナミッド、
#                    ゼネカ、ノバルティス、ホドガヤ、モンサント、ローヌ・プーラン、
#                    旭、永光、兼商、昭和、新富士、双商、菱商、三菱油化
# 2.5.2 2006/01/04 屋号の削除方法を変更
#                  エムダイファーの認識方法を変更
#                  下記屋号を追加
#                    ミカサ、ユーピーエル
#       2006/03/30 パラメータ受け渡しのバグ修正
# 2.5.3 2006/05/11 屋号に「イヅツヤ」を追加
#       2006/10/24 屋号に「トクソー」を追加
